<?php

/*
Copyright (C) 2001-2005
by Justin Woods <justin@woodsmedia.com>
and David Sowder <david@sowder.com>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

// $Id: index.php,v 1.58 2005/05/22 16:54:54 davids Exp $

$WEBSTAMP_WHERE_FILE_NAME=".webstamp.where";

// Check the PHP version before doing anything else
// The check seems to have to be here because webstamp.inc doesn't parse
// under the PHP 3.x that I've tried it with
if( floor( phpversion()) != 4 ) {
  echo "<html>\n";
  echo " <head>\n";
  echo "  <title>Webstamp error</title>\n";
  echo " </head>\n";
  echo " <body bgcolor=\"#ffffff\">\n";
  echo "  <center><font size=+3 color=\"#ff0000\">Webstamp error</font></center><br>\n";
  echo "  The Webstamp framework currently requires PHP version 4.x<br><br>\n";
  echo "  You shouldn't see this message unless you're a Webstamp website developer.<br><br>\n";
  if( !isset( $_SERVER[ 'SERVER_ADMIN' ] ) && isset( $SERVER_ADMIN )) {
    $_SERVER[ 'SERVER_ADMIN' ] = $SERVER_ADMIN;
  }
  echo "  Please notify the server administrator: {$_SERVER[ 'SERVER_ADMIN' ]}\n";
  echo " </body>\n";
  echo "</html>\n";
  die();
}

# **FIXME** Needs to be changed up and now used as a general error, listing any variables that might be available that could be useful, etc.
function bomb_on_silly_error() {
  global $FIRSTREAL, $SECONDREAL;

  // **FIXME**
  echo "<html>\n";
  echo " <head>\n";
  echo "  <title>Oops</title>\n";
  echo " </head>\n";
  echo " <body bgcolor=\"#ffffff\">\n";
  echo "  We made a silly error somewhere and now our site is broken.<br>\n";
  echo "  Perhaps you can at least get somewhere useful from the\n";
  echo "  \"<a href=\"/\">Front Door</a>\"<br>\n";
  echo "  <br>\n";
  echo "  <p>\n";
  echo "   <i>\n";
  echo "    url: {$_SERVER[ 'REQUEST_URI' ]}<br>\n";
  echo "    SCRIPT_FILENAME: {$_SERVER[ 'SCRIPT_FILENAME' ]}<br>\n";
  echo "    FIRSTREAL: $FIRSTREAL<br>\n";
  echo "    SECONDREAL: $SECONDREAL<br>\n";
  echo "   </i>\n";
  echo "  </p>\n";
  echo " </body>\n";
  echo "</html>\n";
  die( '' );
}

#
# **FIXME** BEGIN New Webstamp data file style "where am I" code
#

# Get the Webstamp data file into an array
$webstamp_data_file_lines = file( $WEBSTAMP_WHERE_FILE_NAME );
if( false === $webstamp_data_file_lines ) {
  # The Webstamp data file does not exist or is not readable with the current permissions
  die( '<b>"webstamp webify" has not been run on this directory.  We cannot continue Webstamp processing for this page until that has been completed.</b>' );
}

# Create _WEBSTAMP[] array
$_WEBSTAMP = array();

# Iterate over lines, importing variables into _WEBSTAMP
foreach ($webstamp_data_file_lines as $webstamp_data_file_line) {
  $webstamp_data_file_line = trim( $webstamp_data_file_line );
  # Check for a comment in the line
  # **FIXME** "webstamp webify" needs to fail on '#' being in a directory name
  $pound_pos = strpos( $webstamp_data_file_line, '#' );
  if( false !== $pound_pos ) {
    # We gave a comment
    # Chop out the comment
    $webstamp_data_file_line = substr( $webstamp_data_file_line, 0, $pound_pos );
    $webstamp_data_file_line = trim( $webstamp_data_file_line );
  }
  # Check for a now blank line
  if( '' == $webstamp_data_file_line ) {
    # Ignore blank lines
    continue;
  }
  #echo "DEBUG: line: [${webstamp_data_file_line}]<br>\n";
  # Parse the variable and value
  $equal_pos = strpos( $webstamp_data_file_line, '=' );
  if( false === $equal_pos ) {
    # Line does not contain a variable declaration
    continue;
  }
  $variable_name = substr( $webstamp_data_file_line, 0, $equal_pos );
  #echo "DEBUG: variable_name: [${variable_name}]<br>\n";
  $variable_value = substr( $webstamp_data_file_line, $equal_pos + 1 );
  #echo "DEBUG: variable_value: [${variable_value}]<br>\n";
  $_WEBSTAMP[ $variable_name ] = $variable_value;
}

#echo "DEBUG: _WEBSTAMP BEGIN<br>\n";
#print_r( $_WEBSTAMP );
#echo "<br>\nDEBUG: _WEBSTAMP END<br>\n";

if(
    !array_key_exists( 'RELROOTLIBS', $_WEBSTAMP ) or
    !array_key_exists( 'RELROOTDIR', $_WEBSTAMP ) or
    !array_key_exists( 'RELOURLIBS', $_WEBSTAMP ) or
    !array_key_exists( 'RELOURDIR', $_WEBSTAMP ) or
    !array_key_exists( 'ABSROOTLIBS', $_WEBSTAMP ) or
    !array_key_exists( 'ABSROOTDIR', $_WEBSTAMP ) or
    !array_key_exists( 'ABSOURLIBS', $_WEBSTAMP ) or
    !array_key_exists( 'ABSOURDIR', $_WEBSTAMP ) or
    !array_key_exists( 'ABSTHISDIR', $_WEBSTAMP )
  ) {
  # Webstamp data file does not contain all expected variable declarations
  die( '<b>Webstamp internal data file in this directory is corrupted.  Run "webstamp webify" to recreate the file.  We cannot continue Webstamp processing for this page until that has been completed.</b>' );
}

#
# **FIXME** END New Webstamp data file style "where am I" code
#
  
// Required variable "setup" is below
// Check for existence of _SERVER[ 'SCRIPT_FILENAME' ]
if( !isset( $_SERVER[ 'SCRIPT_FILENAME' ] )) {
  if( isset( $SCRIPT_FILENAME )) {
    $_SERVER[ 'SCRIPT_FILENAME' ] = $SCRIPT_FILENAME;
  } else {
    echo "<html>\n";
    echo " <head>\n";
    echo "  <title>Oops</title>\n";
    echo " </head>\n";
    echo " <body bgcolor=\"#ffffff\">\n";
    echo "  Sorry, our website is broken.  We are working to have it repaired shortly.<br>\n";
    echo "  <br>\n";
    echo "  <code>_SERVER[ 'SCRIPT_FILENAME' ] is undefined</code>\n";
    echo " </body>\n";
    echo "</html>\n";
    die( '' );
  }
}
// Check for existence of _SERVER[ 'REQUEST_URI' ] or _SERVER[ 'SCRIPT_URL' ]
if( !isset( $_SERVER[ 'REQUEST_URI' ] ) and !isset( $_SERVER[ 'SCRIPT_URL' ] )) {
  if( isset( $REQUEST_URI )) {
    $_SERVER[ 'REQUEST_URI' ] = $REQUEST_URI;
  } else if( isset( $SCRIPT_URL )) {
    $_SERVER[ 'REQUEST_URI' ] = $SCRIPT_URL;
  } else {
    echo "<html>\n";
    echo " <head>\n";
    echo "  <title>Oops</title>\n";
    echo " </head>\n";
    echo " <body bgcolor=\"#ffffff\">\n";
    echo "  Sorry, our website is broken.  We are working to have it repaired shortly.<br>\n";
    echo "  <br>\n";
    echo "  <code>_SERVER[ 'REQUEST_URI' ] and _SERVER[ 'SCRIPT_URL' ] are both undefined</code>\n";
    echo " </body>\n";
    echo "</html>\n";
    die( '' );
  }
}
// Fixup if we have _SERVER[ 'SCRIPT_URL' ] but not _SERVER[ 'REQUEST_URI' ]
if( !isset( $_SERVER[ 'REQUEST_URI' ] ) and isset( $_SERVER[ 'SCRIPT_URL' ] )) {
  $_SERVER[ 'REQUEST_URI' ] = $_SERVER[ 'SCRIPT_URL' ];
}
$THISDIR = $_WEBSTAMP[ 'ABSTHISDIR' ];
$RELOURDIR = $_WEBSTAMP[ 'RELOURDIR' ];
$RELROOTDIR = $_WEBSTAMP[ 'RELROOTDIR' ];
$OURDIR = $_WEBSTAMP[ 'ABSOURDIR' ];
$ROOTDIR = $_WEBSTAMP[ 'ABSROOTDIR' ];
$OURLIBS = $_WEBSTAMP[ 'ABSOURLIBS' ];
$ROOTLIBS = $_WEBSTAMP[ 'ABSROOTLIBS' ];
$OURCACHE = $OURDIR . '.cache/';
$ROOTCACHE = $ROOTDIR . '.cache/';
$OURDATA = $OURDIR . '.data/';
$ROOTDATA = $ROOTDIR . '.data/';
$OURGFX = $OURDIR . '.gfx/';
$ROOTGFX = $ROOTDIR . '.gfx/';

/*
echo "<br>\n";
echo "DEBUG: THISDIR: &lt;${THISDIR}&gt;<br>\n";
echo "DEBUG: RELOURDIR: &lt;${RELOURDIR}&gt;<br>\n";
echo "DEBUG: OURDIR: &lt;${OURDIR}&gt;<br>\n";
echo "DEBUG: OURCACHE: &lt;${OURCACHE}&gt;<br>\n";
echo "DEBUG: OURDATA: &lt;${OURDATA}&gt;<br>\n";
echo "DEBUG: OURGFX: &lt;${OURGFX}&gt;<br>\n";
echo "DEBUG: OURLIBS: &lt;${OURLIBS}&gt;<br>\n";
echo "DEBUG: RELROOTDIR: &lt;${RELROOTDIR}&gt;<br>\n";
echo "DEBUG: ROOTDIR: &lt;${ROOTDIR}&gt;<br>\n";
echo "DEBUG: ROOTCACHE: &lt;${ROOTCACHE}&gt;<br>\n";
echo "DEBUG: ROOTDATA: &lt;${ROOTDATA}&gt;<br>\n";
echo "DEBUG: ROOTGFX: &lt;${ROOTGFX}&gt;<br>\n";
echo "DEBUG: ROOTLIBS: &lt;${ROOTLIBS}&gt;<br>\n";
die( '' );
*/

require_once( $_WEBSTAMP[ 'ABSROOTLIBS' ] . 'webstamp.inc' );  // get_reldir_matched_url() needed next
$pos = strrpos( $_SERVER[ 'REQUEST_URI' ], '?' );
if( $pos > 0 ) {
  $CLEANER_URI = substr( $_SERVER[ 'REQUEST_URI' ], 0, $pos );
}
else {
  $CLEANER_URI = $_SERVER[ 'REQUEST_URI' ];
}
$pos = strrpos( $CLEANER_URI, '/' );
if( $pos > 0 ) {
  $CLEANED_URI = substr( $CLEANER_URI, 0, $pos + 1 );
}
else {
  $CLEANED_URI = $CLEANER_URI;
}
$OURURL = get_reldir_matched_url( $RELOURDIR, $CLEANED_URI );
$ROOTURL = get_reldir_matched_url( $RELROOTDIR, $CLEANED_URI );
$OURGFXURL = $OURURL . '.gfx/';
$ROOTGFXURL = $ROOTURL . '.gfx/';
$THISURL = $CLEANED_URI;

if( 0 ) {
  echo "<br>\n";
  echo "DEBUG: THISDIR: &lt;${THISDIR}&gt;<br>\n";
  echo "DEBUG: _WEBSTAMP[ 'ABSTHISDIR' ]: &lt;{$_WEBSTAMP[ 'ABSTHISDIR' ]}&gt;<br>\n";
  echo "DEBUG: THISURL: &lt;${THISURL}&gt;<br>\n";
  echo "DEBUG: RELOURDIR: &lt;${RELOURDIR}&gt;<br>\n";
  echo "DEBUG: _WEBSTAMP[ 'RELOURDIR' ]: &lt;{$_WEBSTAMP[ 'RELOURDIR' ]}&gt;<br>\n";
  echo "DEBUG: OURDIR: &lt;${OURDIR}&gt;<br>\n";
  echo "DEBUG: _WEBSTAMP[ 'ABSOURDIR' ]: &lt;{$_WEBSTAMP[ 'ABSOURDIR' ]}&gt;<br>\n";
  echo "DEBUG: OURCACHE: &lt;${OURCACHE}&gt;<br>\n";
  echo "DEBUG: OURDATA: &lt;${OURDATA}&gt;<br>\n";
  echo "DEBUG: OURGFX: &lt;${OURGFX}&gt;<br>\n";
  echo "DEBUG: OURLIBS: &lt;${OURLIBS}&gt;<br>\n";
  echo "DEBUG: _WEBSTAMP[ 'ABSOURLIBS' ]: &lt;{$_WEBSTAMP[ 'ABSOURLIBS' ]}&gt;<br>\n";
  echo "DEBUG: OURURL: &lt;${OURURL}&gt;<br>\n";
  echo "DEBUG: OURGFXURL: &lt;${OURGFXURL}&gt;<br>\n";
  echo "DEBUG: RELROOTDIR: &lt;${RELROOTDIR}&gt;<br>\n";
  echo "DEBUG: _WEBSTAMP[ 'RELROOTDIR' ]: &lt;{$_WEBSTAMP[ 'RELROOTDIR' ]}&gt;<br>\n";
  echo "DEBUG: ROOTDIR: &lt;${ROOTDIR}&gt;<br>\n";
  echo "DEBUG: _WEBSTAMP[ 'ABSROOTDIR' ]: &lt;{$_WEBSTAMP[ 'ABSROOTDIR' ]}&gt;<br>\n";
  echo "DEBUG: ROOTCACHE: &lt;${ROOTCACHE}&gt;<br>\n";
  echo "DEBUG: ROOTDATA: &lt;${ROOTDATA}&gt;<br>\n";
  echo "DEBUG: ROOTGFX: &lt;${ROOTGFX}&gt;<br>\n";
  echo "DEBUG: ROOTLIBS: &lt;${ROOTLIBS}&gt;<br>\n";
  echo "DEBUG: _WEBSTAMP[ 'ABSROOTLIBS' ]: &lt;{$_WEBSTAMP[ 'ABSROOTLIBS' ]}&gt;<br>\n";
  echo "DEBUG: ROOTURL: &lt;${ROOTURL}&gt;<br>\n";
  echo "DEBUG: ROOTGFXURL: &lt;${ROOTGFXURL}&gt;<br>\n";
  die( '' );
}

require_once( $_WEBSTAMP[ 'ABSROOTLIBS' ] . 'siteconfig.inc' );

//
// Required variable "setup" is above
// Page begins here
// *************************************

$dir_list = get_directory_steps_to_libs_dir( $_SERVER[ 'SCRIPT_FILENAME' ] );

$workingset = implode( '', file( $_WEBSTAMP[ 'ABSOURLIBS' ] . '^MAIN' ));

while( list( $k, $dir ) = each( $dir_list )) {
  $workingset = process( $_WEBSTAMP[ 'ABSOURLIBS' ], $dir, $workingset, '^' );
}
$workingset = process( $_WEBSTAMP[ 'ABSOURLIBS' ], dirname( $_SERVER[ 'SCRIPT_FILENAME' ] ), $workingset );

if( !isset( $_GET[ 'unknowns' ] )) {
  if( isset( $unknowns )) {
    $_GET[ 'unknowns' ] = $unknowns;
  } else {
    $_GET[ 'unknowns' ] = "remove";
  }
}
switch( $_GET[ 'unknowns' ] ) {
  case "keep":
    break;
  case "remove":
    // $workingset = preg_replace("/\{[^}]+\}/", '', $workingset);
    $workingset = ereg_replace("\{=?_?[A-Z][A-Za-z0-9_]*\}", '', $workingset);
    break;
  case "comment":
    // $workingset = preg_replace("/\{([^}]+)\}/", "<!-- Template $varname: Variable \\1 undefined -->", $workingset);
    $workingset = ereg_replace( "\{(=?_?[A-Z][A-Za-z0-9_]*)\}", "<!-- Template Variable '\\1' undefined -->", $workingset);
    break;
}
if( !isset( $_SERVER[ 'HTTP_ACCEPT_ENCODING' ] ) && isset( $HTTP_ACCEPT_ENCODING )) {
  $_SERVER[ 'HTTP_ACCEPT_ENCODING' ] = $HTTP_ACCEPT_ENCODING;
}
if( $USE_COMPRESSION && isset( $_SERVER[ 'HTTP_ACCEPT_ENCODING' ] ) && $encoding = gzip_accepted( $_SERVER[ 'HTTP_ACCEPT_ENCODING' ] )) {
  $gzdata = '\x1f\x8b\x08\x00\x00\x00\x00\x00'; // gzip header
  $size = strlen( $workingset );
  $crc = crc32( $workingset );
  $gzdata .= gzcompress( $workingset, 9 );
  $gzdata = substr( $gzdata, 0, strlen( $gzdata ) - 4 ); // fix crc bug
  $gzdata .= pack( 'V',$crc ) . pack( 'V', $size );
  header( 'Content-Encoding: ' . $encoding );
  header( 'Content-Length: ' . strlen( $gzdata ));
  echo $gzdata;
} else {
  echo $workingset;
}

?>
